/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.musicsearcher.parsers;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;


public class HTMLParser extends Parser<Document, Element> 
{
    @Override
    public Document getDocument(InputStream input) 
    {
        try 
        {
            Document doc = Jsoup.parse(new String(input.readAllBytes()));
//            System.out.println(doc.outerHtml());
            return doc;
        } 
        catch (IOException ex) 
        {
            Logger.getLogger(HTMLParser.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }
    }

    @Override
    public Collection<Element> getResults(Document document, String selector) 
    {
        return document.select(selector);
    }

    @Override
    public String getField(Element object, String selector) 
    {
        Element ele = object.selectFirst(selector);
        return ele.text();
    }
    
    @Override
    public URL getURLField(Element object, URL baseURL, String selector) throws MalformedURLException 
    {
        Element ele = object.selectFirst(selector);
        
        String link;
        if (ele.hasAttr("href"))
            link = ele.attr("href");
        else
            link = ele.text();
        
        URL url;
        if(!link.startsWith("http"))
            url = new URL(baseURL, link);
        else
            url = new URL(link);
        
        return url;
    }
}
