/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.musicsearcher.parsers;

import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import java.util.List;
import javax.json.Json;
import javax.json.JsonObject;
import javax.json.JsonReader;
import javax.json.JsonStructure;
import javax.json.JsonValue;

/**
 *
 * @author jim
 */
public class JSONParser extends Parser<JsonStructure, JsonObject>
{

    @Override
    public JsonStructure getDocument(InputStream input) 
    {
        JsonReader reader = Json.createReader(input);
        return reader.read();
    }

    @Override
    public Collection<JsonObject> getResults(JsonStructure document, String selector) 
    {
        JsonValue value = document.getValue(selector);
        if (value.getValueType() == JsonValue.ValueType.ARRAY)
        {
            return value.asJsonArray().getValuesAs(JsonObject.class);
        }
        else if (value.getValueType() == JsonValue.ValueType.OBJECT)
        {
            return List.of(value.asJsonObject());
        }
        return List.of();
    }

    @Override
    public String getField(JsonObject object, String selector) 
    {
        return object.getValue(selector).toString();
    }

    @Override
    public URL getURLField(JsonObject object, URL baseURL, String selector) throws MalformedURLException 
    {
        String link = getField(object, selector);
        
        URL url;
        if(!link.startsWith("http"))
            url = new URL(baseURL, link);
        else
            url = new URL(link);
        
        return url;
    }
    
    private JsonValue navigate(JsonObject from, String selector)
    {
        return from.getValue(selector);
    }
}
